// Pecon7
// Allows players to restrict items

$restrictedItemDatas = 0;

if(isFile("config/server/restrictedItems.cs"))
	exec("config/server/restrictedItems.cs");
	
if($restrictionProfile::default !$= "")
{
	schedule(0, 0, loadItemRestrictions, $restrictionProfile::default);
}

function loadItemRestrictions(%profile)
{
	$restrictedItemdatas = $restrictionProfile::save[%profile];
	%loadsFailed = 0;
	
	%count = getFieldCount($restrictedItemdatas);
	for(%i = 1; %i < %count; %i++)
	{
		%field = getField($restrictedItemdatas, %i);
		
		if(isObject(%field))
			%field.image.isRestricted = 1;
		else
			%loadsFailed++;
	}
	
	if(%loadsFailed > 0)
		announce(%loadsFailed SPC "out of" SPC %count SPC "items from the default restriction profile could not be found and were disregarded.");
	else
		announce("Loaded item restriction profile.");
		
	return true;
}

package restrictImages
{
	function player::Mountimage(%this, %image, %slot)
	{
		if(%image.isRestricted)
		{
			if(%this.client.isAdmin)
			{
				parent::Mountimage(%this, %image, %slot);
				return;
			}
			%this.client.chatMessage("You do not have permission to use this item.");
			return;
		}
		
		parent::Mountimage(%this, %image, %slot);
	}
};

activatePackage(restrictImages);

function servercmdRestrictItem(%client, %text, %text0, %text1, %text2, %text3, %text4, %text5, %text6, %text7, %text8, %text9, %text10, %text11, %text12, %text13, %text14, %text15, %text16)
{
	if(!%client.isAdmin)
		return;
		

	for(%i = 0; %i <= 16; %i++)
	{
		if(%text[%i] $= "")
			break;
		else
			%text = %text SPC %text[%i];
	}
	
	%text = strLwr(%text);
		
	for(%i = dataBlockGroup.getCount()-1; %i > 0; %i--)
	{
		%data = dataBlockGroup.getObject(%i);
		
		if(strLwr(%data.uiName) $= %text)
		{
			if(!isobject(nameToID(%data.image)))
				continue;
				
			%data = nameToID(%data);
			
			if(%data.image.isRestricted)
			{
				%client.chatMessage("This item is already restricted.");
				return;
			}
			
			%data.image.isRestricted = true;
			//$restrictedItemdata[%data.uiname] = %data;
			$restrictedItemdatas = $restrictedItemdatas TAB %data;
			
			%client.chatMessage(%data.image SPC "(" @ %data.uiName @ ")" SPC "has been restricted from use by non-Admins.");
			return true;
		}
	}
	
	%client.chatMessage("That does not appear to be the name of an item on the server.");
	return false;
}

function servercmdUnRestrictItem(%client, %text, %text0, %text1, %text2, %text3, %text4, %text5, %text6, %text7, %text8, %text9, %text10, %text11, %text12, %text13, %text14, %text15, %text16)
{
	if(!%client.isAdmin)
		return;
		

	for(%i = 0; %i <= 16; %i++)
	{
		if(%text[%i] $= "")
			break;
		else
			%text = %text SPC %text[%i];
	}
	
	%text = strLwr(%text);
		
	for(%i = dataBlockGroup.getCount()-1; %i > 0; %i--)
	{
		%data = dataBlockGroup.getObject(%i);
		
		if(strLwr(%data.uiName) $= %text)
		{
			if(!isobject(nameToID(%data.image)))
				continue;
				
			%data = nameToID(%data);
				
			if(!%data.image.isRestricted)
			{
				%client.chatMessage("That item does not appear to be restricted.");
				if(%data.image.isRestricted !$= "")
					%client.chatMessage("...But it does appear that it used to be restricted.");
				return false;
			}
			
			%data.image.isRestricted = 0;
			//$restrictedItemdata[%data.uiname] = "";
			
			%count = getFieldCount($restrictedItemdatas);
			
			
			for(%ii = 0; %ii < %count; %ii++)
			{
				%field = getField($restrictedItemdatas, %ii);
				
				if(%field == %data)
				{
					$restrictedItemdatas = removeField($restrictedItemdatas, %ii);
					break;
				}
			}
			
			
			%client.chatMessage(%data.image SPC "(" @ %data.uiName @ ")" SPC "has been un-restricted from use by non-Admins.");
			return true;
		}
	}
	
	%client.chatMessage("That does not appear to be the name of an item on the server.");
	return false;
}

function servercmdunRestrictImage(%client, %image)
{
	if(!%client.isSuperAdmin)
		return false;
		
	if(isobject(%image))
	{
		%image.isRestricted = 0;
		%client.chatMessage("Image set as not restricted.");
	}
	else
		%client.chatMesssage("Invalid image.");
		
	return true;
}

function servercmdRestrictImage(%client, %image)
{
	if(!%client.isSuperAdmin)
		return false;
		
	if(setImageAsRestricted(%image))
		%client.chatMessage("Image set as restricted.");
	else
		%client.chatMesssage("Invalid image.");
		
	return true;
}

function setImageAsRestricted(%image, %bool)
{
	if(!isObject(%image = nameToID(%image)))
	{
		warn(%image SPC "is not a valid object!");
		return false;
	}
	
	nameToID(%image).isRestricted = %bool;
	
	return true;
}

function servercmdSaveItemRestrictionProfile(%client, %string)
{
	if(!%client.isSuperAdmin)
		return false;
		
	%string = strupr(%string);
		
	$restrictionProfile::save[%string] = $restrictedItemdatas;
	export("$restrictionProfile*", "config/server/restrictedItems.cs", 0);
	%client.chatMessage("Restriction profile" SPC %string SPC "has been saved.");
	
	return true;
}

function servercmdSetItemRestrictionProfile(%client, %string)
{
	if(!%client.isSuperAdmin)
		return false;

		
	%string = strupr(%string);
	
	if($restrictionProfile::save[%string] $= "")
	{
		%client.chatMessage("That is not the name of a valid save.");
		return false;
	}
	
	%count = getFieldCount($restrictedItemdatas);
	for(%i = 0; %i < %count; %i++)
	{
		%field = getField($restrictedItemdatas, %i);
		
		if(isObject(%field))
			%field.image.isRestricted = 0;
	}
	
	$restrictedItemdatas = $restrictionProfile::save[%string];
	%loadsFailed = 0;
	
	%count = getFieldCount($restrictedItemdatas);
	for(%i = 1; %i < %count; %i++)
	{
		%field = getField($restrictedItemdatas, %i);
		
		if(isObject(%field))
			%field.image.isRestricted = 1;
		else
			%loadsFailed++;
	}
	
	%client.chatMessage("Loaded profiles.");
	
	if(%loadsFailed > 0)
		%client.chatMessage(%loadsFailed SPC "items out of" SPC %i SPC "could not be found and were disregarded.");
		
	return true;
}

function servercmdSetItemRestrictionDefaultProfile(%client, %string)
{
	if(!%client.isSuperAdmin)
		return false;
		
	%string = strupr(%string);
	
	if(%string $= "NONE")
	{
		$restrictionProfile::default = "";
		export("$restrictionProfile*", "config/server/restrictedItems.cs", 0);
		return true;
	}
	
	if($restrictionProfile::save[%string] $= "")
	{
		%client.chatMessage("That is not the name of a valid save.");
		return false;
	}
	
	$restrictionProfile::default = %string;
	
	export("$restrictionProfile*", "config/server/restrictedItems.cs", 0);
	%client.chatMessage("Default profile set. This profile will automatically load upon the server loading.");
	return true;
}

function servercmdClearItemRestrictionDefaultProfile(%client)
{
	if(!%client.isSuperAdmin)
		return false;
		
	if(!$restrictionProfile::default)
	{
		%client.chatMessage("There was no default profile set.");
		return false;
	}
	
	$restrictionProfile::default = "";
	%client.chatMessage("Default profile has been cleared.");
	export("$restrictionProfile*", "config/server/restrictedItems.cs", 0);
	
	return true;
}

function servercmdrestrictionHelp(%client)
{
	if(!%client.isadmin)
		return false;
		
	%client.chatMessage("/restrictItem <name> e.g. \"/restrictItem Homing Rocket\" - Restricts an item");
	%client.chatMessage("/unrestrictItem <name> e.g. \"/unrestrictItem Homing Rocket\" Removes restrictions on an item");
	
	if(!%client.isSuperadmin)
		return;
		
	%client.chatMessage("/saveItemRestrictionProfile <name> e.g. \"/saveItemRestrictionProfile main\" - Saves all current restrictions to a file to be used later");
	%client.chatMessage("/setItemRestrictionProfile <name> e.g. \"/setItemRestrictionProfile main\" - Loads a restriction profile save. This will append current restricted items.");
	%client.chatMessage("/setItemRestrictionDefaultProfile <name> e.g. \"/setItemRestrictionDefaultProfile main\" - Sets a saved profile to be automatically loaded when the server starts.");
	%client.chatMessage("/ClearItemRestrictionDefaultProfile - Removes the currently set default restriction profile.");
}